
Redmine - Feature #10525

A new button to hide/show the sidebar

2012-03-22 16:54 - Jérôme BATAILLE

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate   

Description

On small screens (Netnooks, laptops) the sidebar take some place that is not necessary all the time.

Here are 2 html snippets :

The first to insert just before the closing h1 or h2 tag of the page title :

<span style="float:right"><a href="#" onclick="$('main').toggleClassName('nosidebar');if($('sideba

r_view').src.split('/').pop() == 'minimize.ico'){$('sidebar_view').src='/images/maximize.ico';}els

e{$('sidebar_view').src='/images/minimize.ico';};"><img src="/images/maximize.ico" id="sidebar_vie

w" /></a></span>

 And a second when there are links on the right top corner :

<span><a href="#" onclick="$('main').toggleClassName('nosidebar');if($('sidebar_view').src.split('

/').pop() == 'minimize.ico'){$('sidebar_view').src='/images/maximize.ico';}else{$('sidebar_view').

src='/images/minimize.ico';};"><img src="/images/maximize.ico" id="sidebar_view" /></a></span>

 The 2 icons are to put in public/images

 minimize.ico  maximize.ico 

Related issues:

Related to Redmine - Feature #12032: Collapsible Sidebar Closed

Has duplicate Redmine - Feature #1294: Gantt Chart: Show/Hide Right Menu Closed 2008-05-24

Has duplicate Redmine - Feature #8982: Hide right panel Closed 2011-08-04

Is duplicate of Redmine - Feature #21808: Make the Sidebar collapsible, stateful Closed

History

#1 - 2012-03-22 16:55 - Jérôme BATAILLE

- File maximize.ico added

- File minimize.ico added

#2 - 2012-03-22 17:33 - Yuri Makarov

+1

Additionally,

it would be nice if the size of the sidebar has been fixed.

#3 - 2012-04-29 10:20 - Jean-Philippe Lang

Although this feature is desirable, we just can't add this code to all views. It must be handled by the layout.

Also, hardcoded reference with absolute path to the images won't work with redmine in a sub-uri. It should be handled in the stylesheet.

#4 - 2013-03-19 21:01 - Daniel Felix

- Category set to UI

- Target version set to 2.4.0
#12032 has some additional information regarding this issue.

I have implemented a plain JavaScript solution for this in my theme. But this won't be the best solution, as I just safe the sidebar state in a cookie.

Which means, that the user have to close the sidebar every time he starts his browser (if he remove cookies after closing or if he use the inPrivate

mode).

The better solution would be, to store this information in the session store or in the user profile itself.

Maybe I could provide another patch for this.

I've seen many requests like this, which could be solved with this implementation. This one would be a really small fix, which give a good

improvement for smaller screens or for bigger diagrams.

Best regards,

Daniel

#5 - 2013-03-20 10:20 - Jérôme BATAILLE

I have developped a session like memorization, I'll provide a patch.

But the two issues are still available :

- absolute path to the images

- we must modify each view that needs the button, because me must put it a very precise place with particular parameters if there is a context

dependent menu in the view.

#6 - 2013-03-20 18:57 - Daniel Felix

Jérôme BATAILLE wrote:

I have developped a session like memorization, I'll provide a patch.

 This would be great.

Jérôme BATAILLE wrote:

But the two issues are still available :

- absolute path to the images

 This could be fixed. There could be the same image path implementation as with all the other images in Redmine. :-)

- we must modify each view that needs the button, because me must put it a very precise place with particular parameters if there is a context

dependent menu in the view.

 Well I don't think so. What about just position the sidebar Button directly left beneath the sidebar to let them collapse and the expand  button could be

moved to the outmost right of the page. The div#content could be manipulated to stretch to the right, where the sidebar resides.

Maybe this would be helpfully.

Maybe you can provide the memorization and I will try to port my scripts to be able to run with trunk instead of the theme. :-)

#7 - 2013-03-20 20:21 - Jérôme BATAILLE

I'll see if I have the time to fix these before to provide the patch.

#8 - 2013-04-25 15:48 - Jérôme BATAILLE

- File redmine_smile_togglesidebar_V1.0.tgz added

Here is a plugin.

Tested with Rails 2 and 3.

There is still a manipulation to be done to edit the base layout, to add the button (see the configuration page of the plugin).

#9 - 2013-08-14 12:00 - Vladimir Pitin

- File diamonds.png added

- File close.png added

I would like to share the code that we use to hide / show the sidebar

JS-file
  var close_sidebar = $('<a/>', {href: '#',

                                 class: 'R close_sidebar icon',

                                 click: function(){

                                  if($(this).hasClass('close_sidebar'))

                                    {

                                    $('#sidebar').hide()

                                    $(this).addClass('show_sidebar')

                                    $(this).removeClass('close_sidebar')

                                    $('#content').data('margin-right', $('#content').css('margin-right'))

                                    $('#content').css('margin-right', '16px')

                                    $('#sidebar').before($(this))

                                    }

                                  else

                                    {

                                    $('#sidebar').show()

                                    $(this).removeClass('show_sidebar')

                                    $(this).addClass('close_sidebar')

                                    $('#content').css('margin-right',  $('#content').data('margin-right'))

                                    $('#sidebar').prepend($(this))                                      

                                    }

                                  }

                                })

  $('#sidebar').prepend(close_sidebar)

 CSS - file

a.close_sidebar, a.show_sidebar

  {

  background-repeat: no-repeat;

  background-position: 100% 0%;

  width: 16px;

  height: 16px;

  }

a.close_sidebar

  {

  background-image: url(../images/close.png);

  }

a.show_sidebar

  {

  background-image: url(../images/diamonds.png);

  }

#10 - 2013-08-14 12:20 - Jérôme BATAILLE

Hi, what enhancements do you add (except different button images ?)

#11 - 2013-10-13 10:02 - Jean-Philippe Lang

- Target version changed from 2.4.0 to Candidate for next major release

2.4 feature freeze

#12 - 2014-01-13 21:16 - Jérôme BATAILLE

We have been using the plugin for almost a year, with no embarrassing issue.

The only annoying thing is that if you open the same controller/action in different tabs, the open/closed state of the sidebar will be inconsistent (fixed

with a refresh).

#13 - 2014-05-27 17:19 - Jérôme BATAILLE

Here is the plugin that we have developed and have been using for more than a year :

https://github.com/Smile-SA/redmine_smile_togglesidebar

It's stable and compatible with all versions.

#14 - 2015-10-11 21:43 - Sebastian Paluch

+1
#15 - 2015-12-16 15:11 - Kirill Bezrukov (RedmineUP)

We implemented this feature in our free theme Circle without any plugins requirement

#16 - 2015-12-16 15:22 - Jérôme BATAILLE

Kirill Bezrukov wrote:

We implemented this feature in our free theme Circle without any plugins requirement

 Hi, do you memorize the sidebar state by controller / action ?

#17 - 2016-01-06 07:16 - Go MAEDA

- Has duplicate Feature #8982: Hide right panel added

#18 - 2016-01-23 22:01 - Daniel Ritz

Please have a look at Patch #21808. I implemented a collapsible sidebar from scratch, minimalistic but stateful.

#19 - 2016-01-25 00:12 - Jérôme BATAILLE

Pleased to see that you had the time to re-develop something that I have already developped and just as a patch !

I will not take the time to look at your patch unless you explain to me that you have added new features.

#20 - 2016-01-25 21:08 - Daniel Ritz

Jérôme BATAILLE wrote:

Pleased to see that you had the time to re-develop something that I have already developped and just as a patch !

 I'm sorry you feel offended.

I will not take the time to look at your patch unless you explain to me that you have added new features.

 My patch is a lot simpler (under 1h to develop) and far less intrusive, requires no additional controller or view (hence less to test, I write tests when the

general direction is accepted), features a smooth CSS animation and is done with just a tiny addition in the layout, as requested by JPL. It uses the

cookie method like this plugin https://github.com/bdemirkir/sidebar_hide, but with a lot less code, which also means it's only stateful within a session.

But that's enough for the normal use case...

Also, plugins that lack tests cannot be installed in our productive system by policy. Something so simple as a collapsible sidebar should be core

Redmine, so...

#21 - 2016-01-26 18:02 - Jérôme BATAILLE

Daniel Ritz wrote:

I'm sorry you feel offended.

 Never mind, with your explanations I understand quite well your motivations.

My patch is a lot simpler (under 1h to develop) and far less intrusive, requires no additional controller or view (hence less to test, I write tests

when the general direction is accepted), features a smooth CSS animation and is done with just a tiny addition in the layout, as requested by

JPL.

 I will look at your implementation to see if I can take benefit of it in my plugin.

By the way, how did you get your requests from JPL ?

It uses the cookie method like this plugin https://github.com/bdemirkir/sidebar_hide, but with a lot less code, which also means it's only stateful

within a session. But that's enough for the normal use case...

Also, plugins that lack tests cannot be installed in our productive system by policy. Something so simple as a collapsible sidebar should be core

Redmine, so...

 Testing this part seems complicated to me, but I will take the time to add tests.

#22 - 2016-01-26 19:51 - Daniel Ritz

Jérôme BATAILLE wrote:
Daniel Ritz wrote:

I'm sorry you feel offended.

 Never mind, with your explanations I understand quite well your motivations.

My patch is a lot simpler (under 1h to develop) and far less intrusive, requires no additional controller or view (hence less to test, I write

tests when the general direction is accepted), features a smooth CSS animation and is done with just a tiny addition in the layout, as

requested by JPL.

 I will look at your implementation to see if I can take benefit of it in my plugin.

By the way, how did you get your requests from JPL ?

 Ah no...I was just referring to comment 3 here. That also reminded me to take care of sub-uri. I actually have it deployed at /redmine, but that slips so

easily because stuff works just fine with a cookie's path at / instead of /redmine...

It uses the cookie method like this plugin https://github.com/bdemirkir/sidebar_hide, but with a lot less code, which also means it's only

stateful within a session. But that's enough for the normal use case...

Also, plugins that lack tests cannot be installed in our productive system by policy. Something so simple as a collapsible sidebar should be

core Redmine, so...

 Testing this part seems complicated to me, but I will take the time to add tests.

 I guess just the controller with its views should be fine, the JS part would be Capybara with PhantomJS and stuff...I wouldn't worry too much about

that. I always use simplecov to make sure I get good coverage...and in turn use simplecov on all other plugins just to get an idea if the tests at least

run all code...

#23 - 2016-01-27 18:53 - Jérôme BATAILLE

Daniel Ritz wrote:

Ah no...I was just referring to comment 3 here. That also reminded me to take care of sub-uri. I actually have it deployed at /redmine, but that

slips so easily because stuff works just fine with a cookie's path at / instead of /redmine...

 I have to test my plugin against that.

I guess just the controller with its views should be fine, the JS part would be Capybara with PhantomJS and stuff...I wouldn't worry too much

about that. I always use simplecov to make sure I get good coverage...and in turn use simplecov on all other plugins just to get an idea if the

tests at least run all code...

 Thanks for these informations that will be helpful.

#24 - 2016-01-27 18:55 - Jérôme BATAILLE

I have developped a new version that does not need anymore changing the layout view.

Feel free to test it : https://github.com/Smile-SA/redmine_smile_togglesidebar

#25 - 2016-01-29 02:30 - Jérôme BATAILLE

I have added full tests in new version (1.0.4)

This plugin has been used for more than 2 years in our company and the button appears correctly in all the pages.

#26 - 2016-02-21 15:56 - Toshi MARUYAMA

- Related to Feature #21808: Make the Sidebar collapsible, stateful added

#27 - 2016-11-01 23:25 - Jérôme BATAILLE

Hi,

You can close this issue as we have provided a plugin that is totally compliant with all Redmine versions (tested with last Redmine 3.3.1)

#28 - 2019-04-21 16:05 - Jérôme BATAILLE

Hi,
Plugin still compliant with Redmine V4.0.3

#29 - 2019-08-26 14:24 - Jérôme BATAILLE

- Status changed from New to Resolved

Hi,

I close this issue, as the plugin is maintained and referenced here :

http://www.redmine.org/plugins/redmine_smile_togglesidebar

#30 - 2019-08-26 14:25 - Jérôme BATAILLE

@go, you can close it if you want.

#31 - 2019-09-09 22:20 - Marius BĂLTEANU

- Status changed from Resolved to Closed

- Target version deleted (Candidate for next major release)

- Resolution set to Duplicate

Closing this in favour of #21808 which has multiple patches and a feedback from Jean-Philippe.

#32 - 2019-09-09 22:22 - Marius BĂLTEANU

- Related to deleted (Feature #21808: Make the Sidebar collapsible, stateful)

#33 - 2019-09-09 22:22 - Marius BĂLTEANU

- Is duplicate of Feature #21808: Make the Sidebar collapsible, stateful added

Files

maximize.ico 1.66 KB 2012-03-22 Jérôme BATAILLE

minimize.ico 1.66 KB 2012-03-22 Jérôme BATAILLE

redmine_smile_togglesidebar_V1.0.tgz 9.57 KB 2013-04-25 Jérôme BATAILLE

diamonds.png 1.36 KB 2013-08-14 Vladimir Pitin

close.png 1.31 KB 2013-08-14 Vladimir Pitin

Powered by TCPDF (www.tcpdf.org)

2025-05-01 6/6

http://www.redmine.org/plugins/redmine_smile_togglesidebar
https://www.redmine.org/issues/21808
http://www.tcpdf.org

